-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Ash_Cooldowns", "Ash Cooldowns")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    Cooldowns:Set("locked", false)
    Cooldowns:UpdateSettings()
    
    -- start the bars now
    self:Display()
    
    -- schedule a new test display a every 21 seconds
    self:ScheduleRepeatingEvent("Ash_CooldownsShakedownDisplay", self.Display, 21, self)
    
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- hide the anchor
    Cooldowns:Set("locked", 1)
    Cooldowns:UpdateSettings()

    -- stop display scheduling
    self:CancelScheduledEvent("Ash_CooldownsShakedownDisplay")
    
    -- remove all timers that are shown
    Cooldowns:RemoveAllTimers()

end

function Addon.prototype:Display()

    -- show cooldown timers, with a default duration of 20 seconds
    Cooldowns:ShowTimers(1,4)

end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()