-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Ash_DoTimer", "Ash DoTimer")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    DoTimer:Set("locked", false)
    DoTimer:UpdateSettings()
    
    -- start the bars now
    self:Display()
    
    -- schedule a new test display a every 21 seconds
    self:ScheduleRepeatingEvent("Ash_DoTimerShakedownDisplay", self.Display, 21, self)
    
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- hide the anchor
    DoTimer:Set("locked", 1)
    DoTimer:UpdateSettings()

    -- stop display scheduling
    self:CancelScheduledEvent("Ash_DoTimerShakedownDisplay")
    
    -- remove all timers that are shown
    DoTimer:RemoveAllTimers()

end

function Addon.prototype:Display()

    -- show dot timers, with a default duration of 20 seconds
    DoTimer:ShowTimers(3,4)

end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()