-- localisations
local L = AceLibrary("AceLocale-2.2"):new("ShakedownSomeAddon")
L:RegisterTranslations("enUS", function() return {
    ["Capping Test Info1"] = true,
    ["Capping Test Info2"] = true,
    ["Capping Test Alliance"] = true,
    ["Capping Test Horde"] = true,
    ["Capping Test"] = true,
} end)

-- constants
local TESTICON = "Interface\\Icons\\Ability_ThunderBolt"
local BAR_DURATION = 10
local BAR_FREQUENCY = 5

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Capping", "Capping")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    Capping:Show()
    
    -- show some bars
    self:StartBars()
    
    -- schedule repeating bar shows
    self:ScheduleRepeatingEvent("BigWigsShakedownBars", self.StartBars, BAR_FREQUENCY, self)
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- kill the timers
    self:CancelScheduledEvent("CappingShakedown")
    
    -- hide the anchor
    Capping:Hide()
    
    -- hide the bars
    self:StopBars()
end

function Addon.prototype:StartBars()

    -- get rid of existing bars
    self.StopBars()

    -- start some bars
    Capping:StartBar("Capping Test Info1", BAR_DURATION, TESTICON, "info1", nil, true)
    Capping:StartBar("Capping Test Info2", BAR_DURATION, TESTICON, "info2", nil, true)
    Capping:StartBar("Capping Test Alliance", BAR_DURATION, TESTICON, "alliance")
    Capping:StartBar("Capping Test Horde", BAR_DURATION, TESTICON, "horde")
    Capping:StartBar("Capping Test", BAR_DURATION, TESTICON, "info1")
    
end

function Addon.prototype:StopBars()
    
    -- stop those bars
    Capping:StopBar("Capping Test Info1")
    Capping:StopBar("Capping Test Info2")
    Capping:StopBar("Capping Test Alliance")
    Capping:StopBar("Capping Test Horde")
    Capping:StopBar("Capping Test")
    
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()