-- constants
local INTERVAL = 5

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Chronometer", "Chronometer")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    Chronometer.anchor:Show()
    
    -- start a test now
    Chronometer:RunTest()
    
    -- reschedule more tests at intervals
    self:ScheduleRepeatingEvent("ChronometerShakedownDisplay", Chronometer.RunTest, INTERVAL, Chronometer)
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- stop scheduling tests
    self:CancelScheduledEvent("ChronometerShakedownDisplay")

    -- hide the anchor
    Chronometer.anchor:Hide()
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()