-- note: CooldownTimers2 doesn't use a standard AceConsole set of options, it builds the menu manually.
-- For this reason, the code for showing / hiding is just pulled out of the menu building functions.
-- CDT2 also uses char and doesn't properly support AceDB profiles, so "char" is hardcoded.

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase)

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "CooldownTimers2", "CooldownTimers2")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- unlock the Announces
    CooldownTimers.announce.anchor:Show()
    CooldownTimers.announce.frame:Show()
    CooldownTimers.announce.frame:SetAlpha(1)
    CooldownTimers.announce.alpha = 1
    CooldownTimers.db.char.announce.locked = false
    
    for k, v in pairs(CooldownTimers.db.char.groups) do
        -- unlock the anchor
        v.locked = false
        CooldownTimers.anchors[k]:Show()
        
        -- show sample bar
        CooldownTimers:OnAnchorClick(k, true)
    end

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- lock the Announces
    CooldownTimers.announce.anchor:Hide()
    CooldownTimers.db.char.announce.locked = true

    for k, v in pairs(CooldownTimers.db.char.groups) do
        -- lock the anchor
        v.locked = true
        CooldownTimers.anchors[k]:Hide()
        
        -- hide the sample bar
        CooldownTimers:OnAnchorClick(k, true)
    end

end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()