-- constants
local NUMBER = 5
local LOCAL_ID = "Shakedown HotCandy %d"
local REAL_ID = "HotCandy%s"

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase)

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "HotCandy", "Hot Candy")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    HotCandy:ShowAnchors()

    -- create paused bars, in the same manner as HotCandy:TestBars
    local localID = nil
    local addonID = nil
    for i = 1, NUMBER do
        localID = string.format(LOCAL_ID, i)
        addonID = string.format(REAL_ID, localID)
        HotCandy:ShowCandyBar(localID, 2+(i*2), "Interface\\Icons\\Spell_Holy_Renew", "green", "yellow", "orange", "red") -- this is the HotCandy method, NOT the CandyBar method
        HotCandy:PauseCandyBar(addonID)
    end

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- hide the anchor
    HotCandy:HideAnchors()

    -- kill each of the bars; no need to unregister because set and forget was specified by HotCandy:ShowCandyBar
    local localID = nil
    local addonID = nil
    for i = 1, NUMBER do
        localID = string.format(LOCAL_ID, i)
        addonID = string.format(REAL_ID, localID)
        HotCandy:StartCandyBar(addonID)
        HotCandy:SetCandyBarTimeLeft(addonID, 0)
        HotCandy:SetCandyBarFade(addonID, 0)
    end

end

-- create the instance of this class
local thisAddon = Addon:new()