-- constants
local DURATION = 3600
local DELAY = 1
local NUM_BARS = 4

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- members
Addon.prototype.numStarted = 0

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Incubator", "Incubator")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    Incubator:UnlockAnchor()
    
    -- display a bar
    self:Display()
    
    -- schedule delayed displays for the rest of the bars
    self:ScheduleRepeatingEvent("IncubatorShakedownDisplay", self.Display, DELAY, self)
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- hide the anchor
    Incubator:LockAnchor()

    -- stop display scheduling
    self:CancelScheduledEvent("IncubatorShakedownDisplay")
    
    -- clear all the bars; it might be nice to just stop the ones we started, but that is problematic without getting into the guts of Incubator
    Incubator:ClearAll()
    
    -- reset the count
    self.numStarted = 0
end

function Addon.prototype:Display()
    self:Debug("Display")

    if self.numStarted < NUM_BARS then

        -- start a bar
        Incubator:StartTimer("Incubator", DURATION + GetTime())
        
        -- increment our counter
        self.numStarted = self.numStarted + 1
    
    else
    
        -- stop putting up bars
        self:CancelScheduledEvent("IncubatorShakedownDisplay")
        
        -- reset the count
        self.numStarted = 0
    
    end
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()