-- localisations
local L = AceLibrary("AceLocale-2.2"):new("ShakedownMSBT")
L:RegisterTranslations("enUS", function() return {
    ["Mik's Scrolling Battle Text"] = true,
} end)

-- constants
local FREQUENCY = 1

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "MikScrollingBattleText", L["Mik's Scrolling Battle Text"])
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- display something now
    self:Display()
    
    -- display a message every second
    self:ScheduleRepeatingEvent("MSBTShakedownDisplay", self.Display, FREQUENCY, self)

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- stop display scheduling
    self:CancelScheduledEvent("MSBTShakedownDisplay")

end

function Addon.prototype:Display()

    for k, v in pairs(MSBTProfiles.CurrentProfile.ScrollAreaSettings) do
        MikSBT.DisplayMessage("MSBT "..v.Name, v.Name)
    end
    
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()