-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase)

-- members
Addon.prototype.playerName = ""
Addon.prototype.playerAlreadyInList = false

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "MainAssist", "MainAssist")
    
    self.playerName = UnitName("player")    
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- is player in the custom MT list?
    self.playerAlreadyInList = false
    for k, v in pairs(MainAssist.db.account.tanks.custom) do
        if v == self.playerName then
			self.playerAlreadyInList = true
		end
	end

    -- add player as custom MT
    if not self.playerAlreadyInList then
        MainAssist:AddCustomTank(self.playerName)
    end
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- remove player from custom MT
    if not self.playerAlreadyInList then
        MainAssist:RemoveCustomTank(self.playerName)
    end
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()