-- constants
local BAR_NUMBER = 4
local BAR_DURATION = 31

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "MendWatch", "MendWatch")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor if necessary
    if not MendWatch.anchor:IsVisible() then
        MendWatch:ToggleAnchor()
    end
    
    -- show some bars now
    self:ShowBars()

    --schedule repeating bars
    self:ScheduleRepeatingEvent("MendWatchShakedownBar", self.ShowBars, BAR_DURATION, self)

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    local barID = ""
    
    -- stop the repeating event
    self:CancelScheduledEvent("MendWatchShakedownBar")
    
    -- hide the bars
    for i = 1, BAR_NUMBER do
        barID = i.."-"..i.."-MendWatch"
        MendWatch:SetCandyBarTimeLeft(barID, 1)
        MendWatch:SetCandyBarFade(barID, 1)
    end
    
    -- hide the anchor
    MendWatch:ToggleAnchor()

end

function Addon.prototype:ShowBars()

    -- show a number of bars
    for i = 1, BAR_NUMBER do
        MendWatch:StartTimer(i, "MendWatch", i)
    end

end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()