-- localisations
local L = AceLibrary("AceLocale-2.2"):new("ShakedownQuartz")
L:RegisterTranslations("enUS", function() return {
    ["Quartz"] = true,
} end)

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase)

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "Quartz", L["Quartz"])
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show each of the free bars by calling the "unlock" function
    if Quartz:IsModuleActive("Player", true) then Quartz.options.args.Player.args.lock.set(false) end
    if Quartz:IsModuleActive("Focus", true) then Quartz.options.args.Focus.args.lock.set(false) end
    if Quartz:IsModuleActive("Target", true) then Quartz.options.args.Target.args.lock.set(false) end
    
    -- show the buff bars only if they are free
    if Quartz:IsModuleActive("Buff", true) then
        local db = Quartz:AcquireDBNamespace("Buff")
        if db.profile.focusanchor == "Free" then
            Quartz.options.args.Buff.args.focus.args.focuslock.set(false)
        end
        if db.profile.targetanchor == "Free" then
            Quartz.options.args.Buff.args.target.args.targetlock.set(false)
        end
    end
    
    -- show the mirror bar if it is free
    if Quartz:IsModuleActive("Mirror", true) then
        if Quartz:AcquireDBNamespace("Mirror").profile.mirroranchor == "Free" then
            Quartz.options.args.Mirror.args.mirrorlock.set(false)
        end
    end
    
    -- show the swing bar if it is free
    if Quartz:IsModuleActive("Swing", true) then
        if Quartz:AcquireDBNamespace("Swing").profile.swingposition == "Free" then
            Quartz.options.args.Swing.args.lock.set(false)
        end
    end
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- hide each of the free bars
    if Quartz:IsModuleActive("Player", true) then Quartz.options.args.Player.args.lock.set(true) end
    if Quartz:IsModuleActive("Focus", true) then Quartz.options.args.Focus.args.lock.set(true) end
    if Quartz:IsModuleActive("Target", true) then Quartz.options.args.Target.args.lock.set(true) end
    
    -- hide the buff bars only if they are free
    if Quartz:IsModuleActive("Buff", true) then
        local db = Quartz:AcquireDBNamespace("Buff")
        if db.profile.focusanchor == "Free" then
            Quartz.options.args.Buff.args.focus.args.focuslock.set(true)
        end
        if db.profile.targetanchor == "Free" then
            Quartz.options.args.Buff.args.target.args.targetlock.set(true)
        end
    end
    
    -- hide the mirror bar if it is free
    if Quartz:IsModuleActive("Mirror", true) then
        if Quartz:AcquireDBNamespace("Mirror").profile.mirroranchor == "Free" then
            Quartz.options.args.Mirror.args.mirrorlock.set(true)
        end
    end

    -- hide the swing bar if it is free
    if Quartz:IsModuleActive("Swing", true) then
        if Quartz:AcquireDBNamespace("Swing").profile.swingposition == "Free" then
            Quartz.options.args.Swing.args.lock.set(true)
        end
    end
end                        

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()