-- localisations
local L = AceLibrary("AceLocale-2.2"):new("ShakedownSCT")
L:RegisterTranslations("enUS", function() return {
    ["Scrolling Combat Text"] = true,
} end)

-- constants
local COLOUR = {r=1, g=1, b=1}

-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase, "AceEvent-2.0")

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "sct_options", L["Scrolling Combat Text"])
end

-- extra actions required after the LOD addon has been loaded
function Addon.prototype:Load()
    self:Debug("Addon:Load")

    if not Addon.super.prototype.Load(self) then return end
    
    self:Debug(" SCT loaded OK; checking for SCTD")

    -- hook the test functions for SCTD as well, if it has been installed
    if SCTD then
        --Hook SCT ShowExample
        if (not SCTD:IsHooked(SCT, "ShowExample")) then
            SCTD:Hook(SCT, "ShowExample");
        end
        --Hook SCT ShowTest
        if (not SCTD:IsHooked(SCT, "ShowTest")) then
            SCTD:Hook(SCT, "ShowTest");
        end
    end
    
    -- successful load
    return true
    
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- display something now
    self:Display()
    
    -- schedule a display every second
    self:ScheduleRepeatingEvent("SCTShakedownDisplay", self.Display, 1, self)
    
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- stop display scheduling
    self:CancelScheduledEvent("SCTShakedownDisplay")

end

function Addon.prototype:Display()

   -- display some crits
    SCT:DisplayText(SCT.LOCALS.EXAMPLE, COLOUR, true, "damage", SCT.FRAME1)
    SCT:DisplayText(SCT.LOCALS.EXAMPLE2, COLOUR, true, "damage", SCT.FRAME2)
    if SCTD then
        SCT:DisplayText(SCTD.LOCALS.EXAMPLE, COLOUR, true, "damage", SCT.FRAME3)
    end

    -- display regular
    SCT:ShowTest()
    
end

-- create the instance of this class
local thisAddon = Addon:new()