-- create the class
local AceOO = AceLibrary("AceOO-2.0")
Addon = AceOO.Class(ShakedownAddonBase)

-- members
Addon.prototype.wasVisible = false
Addon.prototype.wasLocked = false

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "XLootMonitor", "XLootMonitor")
end

function Addon.prototype:Activate()

    if not Addon.super.prototype.Activate(self) then return end
    
    -- show the anchor
    self.wasVisible = XLootMonitor.AA.stacks.loot.opts.anchor.get()
    if not self.wasVisible then
        XLootMonitor.AA.stacks.loot.opts.anchor.set()
    end
    
    -- unlock the anchor
    self.wasLocked = XLootMonitor.AA.stacks.loot.opts.lock.get()
    XLootMonitor.AA.stacks.loot.opts.lock.set(false)
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)
    
    -- hide the anchor
    if not self.wasVisible then
        XLootMonitor.AA.stacks.loot.opts.anchor.set()
    end

    -- lock the anchor
    XLootMonitor.AA.stacks.loot.opts.lock.set(self.wasLocked)
end

-- create the instance of this class; parent's constructor will handle registration with the main shakedown code
local thisAddon = Addon:new()